using System;
using System.Text;
using Dbasic;
using System.Windows.Forms;
using System.Collections;
using System.Reflection;
using System.IO;
namespace Dbasic.EnhancedControls
{
    public class CEnhancedObject
    {
        b4p b4p;
        public Hashtable htShemotAzamim = new Hashtable(); //key: object, value: name	
        private object eventObject = null;
        private EventHandler doMethod = null;
        public CEnhancedObject(b4p b4p)
        {
            this.b4p = b4p;
            doMethod = new EventHandler(MetapelEruim2);
        }
        public Control GetControlStringOrRef(object o)
        {
            if (o is string)
                return (Control)b4p.htControls["_" + o.ToString().ToLower(b4p.cul)];
            else
                return (Control)o;
        }
        public void AddRunTimeEvent(object o,string name, string eventName, string subName)
        {
            EventInfo ei = o.GetType().GetEvent(eventName, BindingFlags.IgnoreCase | BindingFlags.Public
                | BindingFlags.Static | BindingFlags.Instance);
            b4p.htSubs.Remove(name + "_" + eventName);
            b4p.htSubs.Add(name + "_" + eventName, b4p.htSubs[subName]);
            if (ei != null)
            {
                ei.AddEventHandler(o, new EventHandler(this.MetapelEruim));
            }
            else
                throw new Exception("Event does not exist in object.");
        }
        public void AddEventsForUnknownControls(object o, string name)
        {
            foreach (EventInfo ei in o.GetType().GetEvents(BindingFlags.Public
                | BindingFlags.Static | BindingFlags.Instance))
            {
                if (b4p.htSubs.Contains(name + "_" + ei.Name.ToLower(b4p.cul)))
                    ei.AddEventHandler(o, new EventHandler(this.MetapelEruim));
            }
        }
        public void MetapelEruim(object sender, EventArgs e)
        {
            if (b4p.tdRunning != System.Threading.Thread.CurrentThread)
            {
                eventObject = sender;
                b4p.mainForm.Invoke(doMethod);
                return;
            }
            object[] o = (object[])sender;
            //o[0] - object , o[1] - eventName
            string name = (string)htShemotAzamim[o[0]];
            b4p.sender = name;
            b4p.del0 del = (b4p.del0) b4p.htSubs[name + "_" + ((string)o[1]).ToLower(b4p.cul)];
            del();
        }
        private void MetapelEruim2(object sender, EventArgs e)
        {
            object[] o = (object[])eventObject;
            eventObject = null;
            //o[0] - object , o[1] - eventName
            string name = (string)htShemotAzamim[o[0]];
            b4p.sender = name;
            b4p.del0 del = (b4p.del0)b4p.htSubs[name + "_" + ((string)o[1]).ToLower(b4p.cul)];
            del();
        }
    }
}
